Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/DataGridContentView.Designer.cs	(revision 15210)
@@ -99,5 +99,5 @@
       // statisticsTextBox
       // 
-      this.statisticsTextBox.Size = new System.Drawing.Size(1133, 13);
+      this.statisticsTextBox.Size = new System.Drawing.Size(421, 13);
       // 
       // btnApplySort
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/FilterView.Designer.cs	(revision 15210)
@@ -62,12 +62,14 @@
       this.label2 = new System.Windows.Forms.Label();
       this.label3 = new System.Windows.Forms.Label();
+      this.bottomPanel = new System.Windows.Forms.Panel();
       this.groupBoxFilter.SuspendLayout();
       this.groupBoxFilterInfo.SuspendLayout();
       this.groupBox1.SuspendLayout();
+      this.bottomPanel.SuspendLayout();
       this.SuspendLayout();
       // 
       // groupBoxFilter
       // 
-      this.groupBoxFilter.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.groupBoxFilter.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.groupBoxFilter.Controls.Add(this.checkedFilterView);
@@ -93,5 +95,5 @@
       // groupBoxFilterInfo
       // 
-      this.groupBoxFilterInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.groupBoxFilterInfo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.groupBoxFilterInfo.Controls.Add(this.lblPercentage);
@@ -103,5 +105,5 @@
       this.groupBoxFilterInfo.Location = new System.Drawing.Point(4, 337);
       this.groupBoxFilterInfo.Name = "groupBoxFilterInfo";
-      this.groupBoxFilterInfo.Size = new System.Drawing.Size(659, 102);
+      this.groupBoxFilterInfo.Size = new System.Drawing.Size(658, 102);
       this.groupBoxFilterInfo.TabIndex = 1;
       this.groupBoxFilterInfo.TabStop = false;
@@ -119,23 +121,23 @@
       // tbPercentage
       // 
-      this.tbPercentage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.tbPercentage.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tbPercentage.Enabled = false;
       this.tbPercentage.Location = new System.Drawing.Point(104, 71);
       this.tbPercentage.Name = "tbPercentage";
-      this.tbPercentage.Size = new System.Drawing.Size(549, 20);
+      this.tbPercentage.Size = new System.Drawing.Size(548, 20);
       this.tbPercentage.TabIndex = 10;
       // 
-      // tbFiltered
-      // 
-      this.tbRemaining.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      // tbRemaining
+      // 
+      this.tbRemaining.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tbRemaining.Enabled = false;
       this.tbRemaining.Location = new System.Drawing.Point(104, 45);
       this.tbRemaining.Name = "tbRemaining";
-      this.tbRemaining.Size = new System.Drawing.Size(549, 20);
+      this.tbRemaining.Size = new System.Drawing.Size(548, 20);
       this.tbRemaining.TabIndex = 9;
       // 
-      // lblFiltered
+      // lblRemaining
       // 
       this.lblRemaining.AutoSize = true;
@@ -148,10 +150,10 @@
       // tbTotal
       // 
-      this.tbTotal.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.tbTotal.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.tbTotal.Enabled = false;
       this.tbTotal.Location = new System.Drawing.Point(104, 19);
       this.tbTotal.Name = "tbTotal";
-      this.tbTotal.Size = new System.Drawing.Size(549, 20);
+      this.tbTotal.Size = new System.Drawing.Size(548, 20);
       this.tbTotal.TabIndex = 7;
       // 
@@ -167,8 +169,8 @@
       // applyFilterButton
       // 
-      this.applyFilterButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.applyFilterButton.Anchor = System.Windows.Forms.AnchorStyles.Right;
       this.applyFilterButton.Cursor = System.Windows.Forms.Cursors.Default;
       this.applyFilterButton.Enabled = false;
-      this.applyFilterButton.Location = new System.Drawing.Point(554, 628);
+      this.applyFilterButton.Location = new System.Drawing.Point(559, 3);
       this.applyFilterButton.Name = "applyFilterButton";
       this.applyFilterButton.Size = new System.Drawing.Size(107, 23);
@@ -180,9 +182,9 @@
       // rBtnOr
       // 
-      this.rBtnOr.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.rBtnOr.Anchor = System.Windows.Forms.AnchorStyles.Left;
       this.rBtnOr.AutoSize = true;
       this.rBtnOr.Cursor = System.Windows.Forms.Cursors.Default;
       this.rBtnOr.Enabled = false;
-      this.rBtnOr.Location = new System.Drawing.Point(60, 634);
+      this.rBtnOr.Location = new System.Drawing.Point(53, 6);
       this.rBtnOr.Name = "rBtnOr";
       this.rBtnOr.Size = new System.Drawing.Size(36, 17);
@@ -193,10 +195,10 @@
       // rBtnAnd
       // 
-      this.rBtnAnd.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.rBtnAnd.Anchor = System.Windows.Forms.AnchorStyles.Left;
       this.rBtnAnd.AutoSize = true;
       this.rBtnAnd.Checked = true;
       this.rBtnAnd.Cursor = System.Windows.Forms.Cursors.Default;
       this.rBtnAnd.Enabled = false;
-      this.rBtnAnd.Location = new System.Drawing.Point(10, 634);
+      this.rBtnAnd.Location = new System.Drawing.Point(3, 6);
       this.rBtnAnd.Name = "rBtnAnd";
       this.rBtnAnd.Size = new System.Drawing.Size(44, 17);
@@ -209,5 +211,5 @@
       // groupBox1
       // 
-      this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.groupBox1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.groupBox1.Controls.Add(this.label4);
@@ -215,7 +217,7 @@
       this.groupBox1.Controls.Add(this.label2);
       this.groupBox1.Controls.Add(this.label3);
-      this.groupBox1.Location = new System.Drawing.Point(7, 445);
+      this.groupBox1.Location = new System.Drawing.Point(4, 445);
       this.groupBox1.Name = "groupBox1";
-      this.groupBox1.Size = new System.Drawing.Size(659, 130);
+      this.groupBox1.Size = new System.Drawing.Size(658, 130);
       this.groupBox1.TabIndex = 12;
       this.groupBox1.TabStop = false;
@@ -261,16 +263,25 @@
       this.label3.Text = "A filter specifies the data rows which should remain.";
       // 
+      // bottomPanel
+      // 
+      this.bottomPanel.Controls.Add(this.applyFilterButton);
+      this.bottomPanel.Controls.Add(this.rBtnAnd);
+      this.bottomPanel.Controls.Add(this.rBtnOr);
+      this.bottomPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
+      this.bottomPanel.Location = new System.Drawing.Point(0, 580);
+      this.bottomPanel.Name = "bottomPanel";
+      this.bottomPanel.Size = new System.Drawing.Size(670, 30);
+      this.bottomPanel.TabIndex = 13;
+      // 
       // FilterView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.bottomPanel);
       this.Controls.Add(this.groupBox1);
-      this.Controls.Add(this.rBtnAnd);
-      this.Controls.Add(this.rBtnOr);
-      this.Controls.Add(this.applyFilterButton);
       this.Controls.Add(this.groupBoxFilterInfo);
       this.Controls.Add(this.groupBoxFilter);
       this.Name = "FilterView";
-      this.Size = new System.Drawing.Size(670, 660);
+      this.Size = new System.Drawing.Size(670, 610);
       this.groupBoxFilter.ResumeLayout(false);
       this.groupBoxFilterInfo.ResumeLayout(false);
@@ -278,6 +289,7 @@
       this.groupBox1.ResumeLayout(false);
       this.groupBox1.PerformLayout();
+      this.bottomPanel.ResumeLayout(false);
+      this.bottomPanel.PerformLayout();
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -302,6 +314,5 @@
     private System.Windows.Forms.Label label2;
     private System.Windows.Forms.Label label3;
-
-
+    private System.Windows.Forms.Panel bottomPanel;
   }
 }
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/HistogramView.cs	(revision 15210)
@@ -39,5 +39,5 @@
       aggregationComboBox.SelectedItem = DataTableVisualProperties.DataTableHistogramAggregation.Overlapping;
       orderComboBox.DataSource = Enum.GetValues(typeof(PreprocessingChartContent.LegendOrder));
-      orderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Appearance;
+      orderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Alphabetically;
     }
 
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.Designer.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.Designer.cs	(revision 15210)
@@ -69,4 +69,5 @@
       // 
       this.splitContainer.Panel2.Controls.Add(this.scrollPanel);
+      this.splitContainer.Panel2.Resize += new System.EventHandler(this.splitContainer_Panel2_Resize);
       // 
       // tableLayoutPanel
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.cs	(revision 15210)
@@ -51,4 +51,5 @@
       dataTables = new Dictionary<string, DataTable>();
       dataTableViews = new Dictionary<string, DataTableView>();
+      scrollPanel.HorizontalScroll.Visible = false;
     }
 
@@ -203,4 +204,25 @@
       GenerateLayout();
     }
+
+    private void splitContainer_Panel2_Resize(object sender, EventArgs e) {
+      if (SuppressCheckedChangedUpdate)
+        return;
+
+      scrollPanel.SuspendRepaint();
+
+      if (tableLayoutPanel.ColumnCount > 0 && tableLayoutPanel.RowCount > 0) {
+        var width = (splitContainer.Panel2.Width - SystemInformation.VerticalScrollBarWidth) / tableLayoutPanel.ColumnCount;
+        var height = width * 0.75f;
+
+        for (int i = 0; i < tableLayoutPanel.RowStyles.Count - 1; i++) {
+          tableLayoutPanel.RowStyles[i].Height = height;
+        }
+        for (int i = 0; i < tableLayoutPanel.ColumnStyles.Count; i++) {
+          tableLayoutPanel.ColumnStyles[i].Width = width;
+        }
+      }
+
+      scrollPanel.ResumeRepaint(true);
+    }
   }
 }
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingIcons.resx
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingIcons.resx	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingIcons.resx	(revision 15210)
@@ -120,11 +120,11 @@
   <assembly alias="System.Windows.Forms" name="System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
   <data name="All" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>icons\all.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+    <value>Icons\All.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
   <data name="Inputs" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>icons\inputs.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+    <value>Icons\Inputs.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
   <data name="None" type="System.Resources.ResXFileRef, System.Windows.Forms">
-    <value>icons\none.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+    <value>Icons\None.png;System.Drawing.Bitmap, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
   </data>
 </root>
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotMultiView.cs	(revision 15210)
@@ -60,5 +60,5 @@
 
       legendOrderComboBox.DataSource = Enum.GetValues(typeof(PreprocessingChartContent.LegendOrder));
-      legendOrderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Appearance;
+      legendOrderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Alphabetically;
 
       #region Initialize Scrollbars
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/ScatterPlotSingleView.cs	(revision 15210)
@@ -48,5 +48,5 @@
       regressionTypeComboBox.SelectedItem = RegressionType.None;
       orderComboBox.DataSource = Enum.GetValues(typeof(PreprocessingChartContent.LegendOrder));
-      orderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Appearance;
+      orderComboBox.SelectedItem = PreprocessingChartContent.LegendOrder.Alphabetically;
     }
 
@@ -74,5 +74,5 @@
       comboBoxYVariable.Items.AddRange(variables.ToArray());
       comboBoxGroup.Items.Add(NoGroupItem);
-      foreach (string var in Content.PreprocessingData.VariableNames) {
+      foreach (string var in PreprocessingChartContent.GetVariableNamesForGrouping(Content.PreprocessingData, 50)) {
         comboBoxGroup.Items.Add(var);
       }
@@ -148,4 +148,5 @@
 
     private void comboBoxYVariable_SelectedIndexChanged(object sender, EventArgs e) {
+      SuspendRepaint();
       var oldPlot = scatterPlotView.Content;
       UpdateScatterPlot();
@@ -163,4 +164,5 @@
         x.nr.VisualProperties = newVisuapProperties;
       }
+      ResumeRepaint(true);
     }
 
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.Designer.cs	(revision 15210)
@@ -53,7 +53,4 @@
       this.stringMatrixView = new HeuristicLab.Data.Views.StringConvertibleMatrixView();
       this.showVariablesGroupBox = new System.Windows.Forms.GroupBox();
-      this.checkInputsTargetButton = new System.Windows.Forms.Button();
-      this.uncheckAllButton = new System.Windows.Forms.Button();
-      this.checkAllButton = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
       this.lblTNumValues = new System.Windows.Forms.Label();
@@ -69,4 +66,7 @@
       this.missingValuesTextBox = new System.Windows.Forms.TextBox();
       this.overviewGroupBox = new System.Windows.Forms.GroupBox();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
       this.showVariablesGroupBox.SuspendLayout();
       this.orientationGroupBox.SuspendLayout();
@@ -101,5 +101,5 @@
       this.lblMissingValuesTotal.AutoSize = true;
       this.lblMissingValuesTotal.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblMissingValuesTotal.Location = new System.Drawing.Point(237, 26);
+      this.lblMissingValuesTotal.Location = new System.Drawing.Point(275, 26);
       this.lblMissingValuesTotal.Name = "lblMissingValuesTotal";
       this.lblMissingValuesTotal.Size = new System.Drawing.Size(77, 26);
@@ -112,5 +112,5 @@
       this.lblNumericColumns.AutoSize = true;
       this.lblNumericColumns.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblNumericColumns.Location = new System.Drawing.Point(100, 0);
+      this.lblNumericColumns.Location = new System.Drawing.Point(119, 0);
       this.lblNumericColumns.Name = "lblNumericColumns";
       this.lblNumericColumns.Size = new System.Drawing.Size(92, 26);
@@ -123,5 +123,5 @@
       this.lblNominalColumns.AutoSize = true;
       this.lblNominalColumns.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblNominalColumns.Location = new System.Drawing.Point(100, 26);
+      this.lblNominalColumns.Location = new System.Drawing.Point(119, 26);
       this.lblNominalColumns.Name = "lblNominalColumns";
       this.lblNominalColumns.Size = new System.Drawing.Size(92, 26);
@@ -142,5 +142,5 @@
       this.stringMatrixView.ShowRowsAndColumnsTextBox = false;
       this.stringMatrixView.ShowStatisticalInformation = true;
-      this.stringMatrixView.Size = new System.Drawing.Size(592, 331);
+      this.stringMatrixView.Size = new System.Drawing.Size(655, 374);
       this.stringMatrixView.TabIndex = 4;
       // 
@@ -150,5 +150,5 @@
       this.showVariablesGroupBox.Controls.Add(this.uncheckAllButton);
       this.showVariablesGroupBox.Controls.Add(this.checkAllButton);
-      this.showVariablesGroupBox.Location = new System.Drawing.Point(393, 0);
+      this.showVariablesGroupBox.Location = new System.Drawing.Point(458, 0);
       this.showVariablesGroupBox.Name = "showVariablesGroupBox";
       this.showVariablesGroupBox.Size = new System.Drawing.Size(97, 71);
@@ -157,42 +157,9 @@
       this.showVariablesGroupBox.Text = "Show Variables";
       // 
-      // checkInputsTargetButton
-      // 
-      this.checkInputsTargetButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.Inputs;
-      this.checkInputsTargetButton.Location = new System.Drawing.Point(36, 19);
-      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
-      this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
-      this.checkInputsTargetButton.TabIndex = 14;
-      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Show Inputs & Target");
-      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
-      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
-      // 
-      // uncheckAllButton
-      // 
-      this.uncheckAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.None;
-      this.uncheckAllButton.Location = new System.Drawing.Point(66, 19);
-      this.uncheckAllButton.Name = "uncheckAllButton";
-      this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
-      this.uncheckAllButton.TabIndex = 12;
-      this.toolTip.SetToolTip(this.uncheckAllButton, "Show None");
-      this.uncheckAllButton.UseVisualStyleBackColor = true;
-      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
-      // 
-      // checkAllButton
-      // 
-      this.checkAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.All;
-      this.checkAllButton.Location = new System.Drawing.Point(6, 19);
-      this.checkAllButton.Name = "checkAllButton";
-      this.checkAllButton.Size = new System.Drawing.Size(24, 24);
-      this.checkAllButton.TabIndex = 13;
-      this.toolTip.SetToolTip(this.checkAllButton, "Show All");
-      this.checkAllButton.UseVisualStyleBackColor = true;
-      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
-      // 
       // lblTNumValues
       // 
       this.lblTNumValues.AutoSize = true;
       this.lblTNumValues.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.lblTNumValues.Location = new System.Drawing.Point(237, 0);
+      this.lblTNumValues.Location = new System.Drawing.Point(275, 0);
       this.lblTNumValues.Name = "lblTNumValues";
       this.lblTNumValues.Size = new System.Drawing.Size(77, 26);
@@ -206,5 +173,5 @@
       this.orientationGroupBox.Controls.Add(this.verticalRadioButton);
       this.orientationGroupBox.Controls.Add(this.horizontalRadioButton);
-      this.orientationGroupBox.Location = new System.Drawing.Point(496, 0);
+      this.orientationGroupBox.Location = new System.Drawing.Point(561, 0);
       this.orientationGroupBox.Name = "orientationGroupBox";
       this.orientationGroupBox.Size = new System.Drawing.Size(94, 71);
@@ -216,4 +183,5 @@
       // 
       this.verticalRadioButton.AutoSize = true;
+      this.verticalRadioButton.Checked = true;
       this.verticalRadioButton.Location = new System.Drawing.Point(6, 32);
       this.verticalRadioButton.Name = "verticalRadioButton";
@@ -228,10 +196,8 @@
       // 
       this.horizontalRadioButton.AutoSize = true;
-      this.horizontalRadioButton.Checked = true;
       this.horizontalRadioButton.Location = new System.Drawing.Point(6, 14);
       this.horizontalRadioButton.Name = "horizontalRadioButton";
       this.horizontalRadioButton.Size = new System.Drawing.Size(72, 17);
       this.horizontalRadioButton.TabIndex = 0;
-      this.horizontalRadioButton.TabStop = true;
       this.horizontalRadioButton.Text = "Horizontal";
       this.horizontalRadioButton.UseVisualStyleBackColor = true;
@@ -244,6 +210,7 @@
       this.rowsTextBox.Name = "rowsTextBox";
       this.rowsTextBox.ReadOnly = true;
-      this.rowsTextBox.Size = new System.Drawing.Size(33, 20);
+      this.rowsTextBox.Size = new System.Drawing.Size(52, 20);
       this.rowsTextBox.TabIndex = 18;
+      this.rowsTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       // 
       // columnsTextBox
@@ -253,15 +220,17 @@
       this.columnsTextBox.Name = "columnsTextBox";
       this.columnsTextBox.ReadOnly = true;
-      this.columnsTextBox.Size = new System.Drawing.Size(33, 20);
+      this.columnsTextBox.Size = new System.Drawing.Size(52, 20);
       this.columnsTextBox.TabIndex = 18;
+      this.columnsTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       // 
       // totalValuesTextBox
       // 
       this.totalValuesTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.totalValuesTextBox.Location = new System.Drawing.Point(320, 3);
+      this.totalValuesTextBox.Location = new System.Drawing.Point(358, 3);
       this.totalValuesTextBox.Name = "totalValuesTextBox";
       this.totalValuesTextBox.ReadOnly = true;
-      this.totalValuesTextBox.Size = new System.Drawing.Size(55, 20);
+      this.totalValuesTextBox.Size = new System.Drawing.Size(82, 20);
       this.totalValuesTextBox.TabIndex = 18;
+      this.totalValuesTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       // 
       // overviewTableLayoutPanel
@@ -293,5 +262,5 @@
       this.overviewTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
       this.overviewTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100F));
-      this.overviewTableLayoutPanel.Size = new System.Drawing.Size(378, 52);
+      this.overviewTableLayoutPanel.Size = new System.Drawing.Size(443, 52);
       this.overviewTableLayoutPanel.TabIndex = 19;
       // 
@@ -299,27 +268,30 @@
       // 
       this.numericColumnsTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.numericColumnsTextBox.Location = new System.Drawing.Point(198, 3);
+      this.numericColumnsTextBox.Location = new System.Drawing.Point(217, 3);
       this.numericColumnsTextBox.Name = "numericColumnsTextBox";
       this.numericColumnsTextBox.ReadOnly = true;
-      this.numericColumnsTextBox.Size = new System.Drawing.Size(33, 20);
+      this.numericColumnsTextBox.Size = new System.Drawing.Size(52, 20);
       this.numericColumnsTextBox.TabIndex = 18;
+      this.numericColumnsTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       // 
       // nominalColumnsTextBox5
       // 
       this.nominalColumnsTextBox5.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.nominalColumnsTextBox5.Location = new System.Drawing.Point(198, 29);
+      this.nominalColumnsTextBox5.Location = new System.Drawing.Point(217, 29);
       this.nominalColumnsTextBox5.Name = "nominalColumnsTextBox5";
       this.nominalColumnsTextBox5.ReadOnly = true;
-      this.nominalColumnsTextBox5.Size = new System.Drawing.Size(33, 20);
+      this.nominalColumnsTextBox5.Size = new System.Drawing.Size(52, 20);
       this.nominalColumnsTextBox5.TabIndex = 18;
+      this.nominalColumnsTextBox5.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       // 
       // missingValuesTextBox
       // 
       this.missingValuesTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.missingValuesTextBox.Location = new System.Drawing.Point(320, 29);
+      this.missingValuesTextBox.Location = new System.Drawing.Point(358, 29);
       this.missingValuesTextBox.Name = "missingValuesTextBox";
       this.missingValuesTextBox.ReadOnly = true;
-      this.missingValuesTextBox.Size = new System.Drawing.Size(55, 20);
+      this.missingValuesTextBox.Size = new System.Drawing.Size(82, 20);
       this.missingValuesTextBox.TabIndex = 18;
+      this.missingValuesTextBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
       // 
       // overviewGroupBox
@@ -328,8 +300,41 @@
       this.overviewGroupBox.Location = new System.Drawing.Point(3, 0);
       this.overviewGroupBox.Name = "overviewGroupBox";
-      this.overviewGroupBox.Size = new System.Drawing.Size(384, 71);
+      this.overviewGroupBox.Size = new System.Drawing.Size(449, 71);
       this.overviewGroupBox.TabIndex = 20;
       this.overviewGroupBox.TabStop = false;
       this.overviewGroupBox.Text = "Overview";
+      // 
+      // checkInputsTargetButton
+      // 
+      this.checkInputsTargetButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.Inputs;
+      this.checkInputsTargetButton.Location = new System.Drawing.Point(36, 19);
+      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
+      this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
+      this.checkInputsTargetButton.TabIndex = 14;
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Show Inputs & Target");
+      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
+      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
+      // 
+      // uncheckAllButton
+      // 
+      this.uncheckAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.None;
+      this.uncheckAllButton.Location = new System.Drawing.Point(66, 19);
+      this.uncheckAllButton.Name = "uncheckAllButton";
+      this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
+      this.uncheckAllButton.TabIndex = 12;
+      this.toolTip.SetToolTip(this.uncheckAllButton, "Show None");
+      this.uncheckAllButton.UseVisualStyleBackColor = true;
+      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
+      // 
+      // checkAllButton
+      // 
+      this.checkAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.All;
+      this.checkAllButton.Location = new System.Drawing.Point(6, 19);
+      this.checkAllButton.Name = "checkAllButton";
+      this.checkAllButton.Size = new System.Drawing.Size(24, 24);
+      this.checkAllButton.TabIndex = 13;
+      this.toolTip.SetToolTip(this.checkAllButton, "Show All");
+      this.checkAllButton.UseVisualStyleBackColor = true;
+      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
       // 
       // StatisticsView
@@ -342,5 +347,5 @@
       this.Controls.Add(this.stringMatrixView);
       this.Name = "StatisticsView";
-      this.Size = new System.Drawing.Size(598, 408);
+      this.Size = new System.Drawing.Size(661, 451);
       this.showVariablesGroupBox.ResumeLayout(false);
       this.orientationGroupBox.ResumeLayout(false);
Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/StatisticsView.cs	(revision 15210)
@@ -34,5 +34,5 @@
   [Content(typeof(StatisticsContent), true)]
   public partial class StatisticsView : ItemView {
-    private bool horizontal = true;
+    private bool horizontal = false;
     private StringMatrix statisticsMatrix;
     private static readonly string[] StatisticsNames = new[] {
Index: trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/HistogramContent.cs	(revision 15210)
@@ -54,5 +54,5 @@
     }
 
-    public static DataTable CreateHistogram(IFilteredPreprocessingData preprocessingData, string variableName, string groupingVariableName, DataTableVisualProperties.DataTableHistogramAggregation aggregation, LegendOrder legendOrder = LegendOrder.Appearance) {
+    public static DataTable CreateHistogram(IFilteredPreprocessingData preprocessingData, string variableName, string groupingVariableName, DataTableVisualProperties.DataTableHistogramAggregation aggregation, LegendOrder legendOrder = LegendOrder.Alphabetically) {
       var dataTable = new DataTable {
         VisualProperties = { Title = variableName, HistogramAggregation = aggregation },
Index: trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/PreprocessingChartContent.cs	(revision 15210)
@@ -34,6 +34,6 @@
   public class PreprocessingChartContent : Item, IViewShortcut {
     public enum LegendOrder {
-      Appearance,
-      Alphabetically
+      Alphabetically,
+      Appearance
     }
 
@@ -91,6 +91,5 @@
     }
 
-    private const int MAX_DISTINCT_VALUES_FOR_GROUPING = 20;
-    public static IEnumerable<string> GetVariableNamesForGrouping(IPreprocessingData preprocessingData) {
+    public static IEnumerable<string> GetVariableNamesForGrouping(IPreprocessingData preprocessingData, int maxDistinctValues = 20) {
       var variableNames = new List<string>();
 
@@ -104,5 +103,5 @@
           distinctValues = preprocessingData.GetValues<DateTime>(i).GroupBy(x => x).Count();
 
-        if (distinctValues <= MAX_DISTINCT_VALUES_FOR_GROUPING)
+        if (distinctValues <= maxDistinctValues)
           variableNames.Add(preprocessingData.GetVariableName(i));
       }
Index: trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs	(revision 15209)
+++ trunk/sources/HeuristicLab.DataPreprocessing/3.4/Content/ScatterPlotContent.cs	(revision 15210)
@@ -40,5 +40,5 @@
     }
 
-    public static ScatterPlot CreateScatterPlot(IFilteredPreprocessingData preprocessingData, string variableNameX, string variableNameY, string variableNameGroup = "-", LegendOrder legendOrder = LegendOrder.Appearance) {
+    public static ScatterPlot CreateScatterPlot(IFilteredPreprocessingData preprocessingData, string variableNameX, string variableNameY, string variableNameGroup = "-", LegendOrder legendOrder = LegendOrder.Alphabetically) {
       ScatterPlot scatterPlot = new ScatterPlot();
 